Index: squid/src/forward.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/forward.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/forward.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/forward.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: forward.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: forward.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 17    Request Forwarding
  * AUTHOR: Duane Wessels
@@ -112,7 +112,7 @@
 	return 0;
     if (fwdState->flags.dont_retry)
 	return 0;
-    if (pumpMethod(fwdState->request->method))
+    if (fwdState->request->content_length >= 0)
 	if (0 == pumpRestart(fwdState->request))
 	    return 0;
     return 1;
@@ -139,7 +139,7 @@
 	    fs->next = NULL;
 	}
 	/* use eventAdd to break potential call sequence loops */
-	eventAdd("fwdConnectStart", fwdConnectStart, fwdState, 0.0, 1);
+	eventAdd("fwdConnectStart", fwdConnectStart, fwdState, 0.0, 0);
     } else {
 	fwdStateFree(fwdState);
     }
@@ -217,15 +217,19 @@
     FwdServer *fs = fwdState->servers;
     const char *host;
     unsigned short port;
+    time_t ctimeout;
     assert(fs);
     assert(fwdState->server_fd == -1);
     debug(17, 3) ("fwdConnectStart: %s\n", url);
     if (fs->peer) {
 	host = fs->peer->host;
 	port = fs->peer->http_port;
+	ctimeout = fs->peer->connect_timeout > 0 ? fs->peer->connect_timeout
+	    : Config.Timeout.peer_connect;
     } else {
 	host = fwdState->request->host;
 	port = fwdState->request->port;
+	ctimeout = Config.Timeout.connect;
     }
     hierarchyNote(&fwdState->request->hier, fs->code, host);
     if ((fd = pconnPop(host, port)) >= 0) {
@@ -255,7 +259,7 @@
     fwdState->n_tries++;
     comm_add_close_handler(fd, fwdServerClosed, fwdState);
     commSetTimeout(fd,
-	Config.Timeout.connect,
+	ctimeout,
 	fwdConnectTimeout,
 	fwdState);
     commConnectStart(fd, host, port, fwdConnectDone, fwdState);
@@ -292,6 +296,7 @@
     peer *p;
     request_t *request = fwdState->request;
     StoreEntry *entry = fwdState->entry;
+    ErrorState *err;
     debug(17, 3) ("fwdDispatch: FD %d: Fetching '%s %s'\n",
 	fwdState->client_fd,
 	RequestMethodStr[request->method],
@@ -309,6 +314,7 @@
     assert(fwdState->server_fd > -1);
     if (fwdState->servers && (p = fwdState->servers->peer)) {
 	p->stats.fetches++;
+	fwdState->request->peer_login = p->login;
 	httpStart(fwdState);
     } else {
 	switch (request->protocol) {
@@ -335,7 +341,20 @@
 	default:
 	    debug(17, 1) ("fwdDispatch: Cannot retrieve '%s'\n",
 		storeUrl(entry));
-	    fwdFail(fwdState, errorCon(ERR_UNSUP_REQ, HTTP_BAD_REQUEST));
+	    err = errorCon(ERR_UNSUP_REQ, HTTP_BAD_REQUEST);
+	    err->request = requestLink(request);
+	    fwdFail(fwdState, err);
+	    /*
+	     * Force a persistent connection to be closed because
+	     * some Netscape browsers have a bug that sends CONNECT
+	     * requests as GET's over persistent connections.
+	     */
+	    request->flags.proxy_keepalive = 0;
+	    /*
+	     * Set the dont_retry flag becuase this is not a
+	     * transient (network) error; its a bug.
+	     */
+	    fwdState->flags.dont_retry = 1;
 	    comm_close(fwdState->server_fd);
 	    break;
 	}
@@ -357,7 +376,7 @@
     }
     if (fwdState->n_tries > 9)
 	return 0;
-    if (pumpMethod(fwdState->request->method))
+    if (fwdState->request->content_length >= 0)
 	if (0 == pumpRestart(fwdState->request))
 	    return 0;
     assert(fs);
@@ -385,8 +404,7 @@
 }
 
 void
-fwdStart(int fd, StoreEntry * e, request_t * r, struct in_addr client_addr,
-    struct in_addr my_addr)
+fwdStart(int fd, StoreEntry * e, request_t * r)
 {
     FwdState *fwdState;
     aclCheck_t ch;
@@ -397,19 +415,20 @@
      * from peer_digest.c, asn.c, netdb.c, etc and should always
      * be allowed.  yuck, I know.
      */
-    if (client_addr.s_addr != no_addr.s_addr) {
+    if (r->client_addr.s_addr != no_addr.s_addr) {
 	/*      
 	 * Check if this host is allowed to fetch MISSES from us (miss_access)
 	 */
 	memset(&ch, '\0', sizeof(aclCheck_t));
-	ch.src_addr = client_addr;
-	ch.my_addr = my_addr;
+	ch.src_addr = r->client_addr;
+	ch.my_addr = r->my_addr;
+	ch.my_port = r->my_port;
 	ch.request = r;
 	answer = aclCheckFast(Config.accessList.miss, &ch);
 	if (answer == 0) {
 	    err = errorCon(ERR_FORWARDING_DENIED, HTTP_FORBIDDEN);
 	    err->request = requestLink(r);
-	    err->src_addr = client_addr;
+	    err->src_addr = r->client_addr;
 	    errorAppendEntry(e, err);
 	    return;
 	}
@@ -458,6 +477,7 @@
 {
     StoreEntry *e = data;
     MemObject *mem = e->mem_obj;
+    int rc = 0;
     if (mem == NULL)
 	return 0;
 #if DELAY_POOLS
@@ -465,13 +485,21 @@
 	(void) 0;
     else if (delayIsNoDelay(fd))
 	(void) 0;
-    else if (delayMostBytesWanted(mem, 1) == 0)
-	return 1;
+    else {
+	int i = delayMostBytesWanted(mem, INT_MAX);
+	if (0 == i)
+	    return 1;
+	/* was: rc = -(rc != INT_MAX); */
+	else if (INT_MAX == i)
+	    rc = 0;
+	else
+	    rc = -1;
+    }
 #endif
     if (EBIT_TEST(e->flags, ENTRY_FWD_HDR_WAIT))
-	return 0;
+	return rc;
     if (mem->inmem_hi - storeLowestMemReaderOffset(e) < READ_AHEAD_GAP)
-	return 0;
+	return rc;
     return 1;
 }
 
@@ -491,7 +519,7 @@
 /*
  * Called when someone else calls StoreAbort() on this entry
  */
-void
+static void
 fwdAbort(void *data)
 {
     FwdState *fwdState = data;
Index: squid/src/fqdncache.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fqdncache.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/fqdncache.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/fqdncache.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,7 +1,7 @@
 
 
 /*
- * $Id: fqdncache.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: fqdncache.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 35    FQDN Cache
  * AUTHOR: Harvest Derived
@@ -52,8 +52,13 @@
 
 static dlink_list lru_list;
 
+#if USE_DNSSERVERS
 static HLPCB fqdncacheHandleReply;
 static fqdncache_entry *fqdncacheParse(const char *buf);
+#else
+static IDNSCB fqdncacheHandleReply;
+static fqdncache_entry *fqdncacheParse(rfc1035_rr *, int);
+#endif
 static void fqdncache_release(fqdncache_entry *);
 static fqdncache_entry *fqdncache_create(const char *name);
 static void fqdncache_call_pending(fqdncache_entry *);
@@ -220,8 +225,8 @@
     fqdncacheUnlockEntry(f);
 }
 
-
 static fqdncache_entry *
+#if USE_DNSSERVERS
 fqdncacheParse(const char *inbuf)
 {
     LOCAL_ARRAY(char, buf, DNS_INBUF_SZ);
@@ -271,9 +276,54 @@
     }
     return &f;
 }
+#else
+fqdncacheParse(rfc1035_rr * answers, int nr)
+{
+    static fqdncache_entry f;
+    int k;
+    int j;
+    int na = 0;
+    memset(&f, '\0', sizeof(f));
+    f.expires = squid_curtime;
+    f.status = FQDN_NEGATIVE_CACHED;
+    if (nr < 0) {
+	debug(35, 3) ("fqdncacheParse: Lookup failed (error %d)\n",
+	    rfc1035_errno);
+	assert(rfc1035_error_message);
+	f.error_message = xstrdup(rfc1035_error_message);
+	return &f;
+    }
+    if (nr == 0) {
+	debug(35, 3) ("fqdncacheParse: No DNS records\n");
+	f.error_message = xstrdup("No DNS records");
+	return &f;
+    }
+    debug(35, 3) ("fqdncacheParse: %d answers\n", nr);
+    assert(answers);
+    for (j = 0, k = 0; k < nr; k++) {
+	if (answers[k].type != RFC1035_TYPE_PTR)
+	    continue;
+	if (answers[k].class != RFC1035_CLASS_IN)
+	    continue;
+	na++;
+	f.status = FQDN_CACHED;
+	f.names[0] = xstrdup(answers[k].rdata);
+	f.name_count = 1;
+	f.expires = squid_curtime + answers[k].ttl;
+	return &f;
+    }
+    debug(35, 1) ("fqdncacheParse: No PTR record\n");
+    f.error_message = xstrdup("No PTR record");
+    return &f;
+}
+#endif
 
 static void
+#if USE_DNSSERVERS
 fqdncacheHandleReply(void *data, char *reply)
+#else
+fqdncacheHandleReply(void *data, rfc1035_rr * answers, int na)
+#endif
 {
     int n;
     generic_cbdata *c = data;
@@ -286,7 +336,11 @@
     n = ++FqdncacheStats.replies;
     statHistCount(&Counter.dns.svc_time,
 	tvSubMsec(f->request_time, current_time));
+#if USE_DNSSERVERS
     x = fqdncacheParse(reply);
+#else
+    x = fqdncacheParse(answers, na);
+#endif
     assert(x);
     f->name_count = x->name_count;
     for (n = 0; n < (int) f->name_count; n++)
@@ -369,7 +423,11 @@
     cbdataAdd(c, cbdataXfree, 0);
     f->status = FQDN_DISPATCHED;
     fqdncacheLockEntry(f);	/* lock while FQDN_DISPATCHED */
+#if USE_DNSSERVERS
     dnsSubmit(f->name, fqdncacheHandleReply, c);
+#else
+    idnsPTRLookup(addr, fqdncacheHandleReply, c);
+#endif
 }
 
 /* initialize the fqdncache */
@@ -622,46 +680,50 @@
 variable_list *
 snmp_netFqdnFn(variable_list * Var, snint * ErrP)
 {
-    variable_list *Answer;
-
+    variable_list *Answer = NULL;
     debug(49, 5) ("snmp_netFqdnFn: Processing request:\n", Var->name[LEN_SQ_NET +
 	    1]);
     snmpDebugOid(5, Var->name, Var->name_length);
-
-    Answer = snmp_var_new(Var->name, Var->name_length);
     *ErrP = SNMP_ERR_NOERROR;
-    Answer->val_len = sizeof(snint);
-    Answer->val.integer = xmalloc(Answer->val_len);
-    Answer->type = SMI_COUNTER32;
-
     switch (Var->name[LEN_SQ_NET + 1]) {
     case FQDN_ENT:
-	*(Answer->val.integer) = memInUse(MEM_FQDNCACHE_ENTRY);
-	Answer->type = SMI_GAUGE32;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    memInUse(MEM_FQDNCACHE_ENTRY),
+	    SMI_GAUGE32);
 	break;
     case FQDN_REQ:
-	*(Answer->val.integer) = FqdncacheStats.requests;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    FqdncacheStats.requests,
+	    SMI_COUNTER32);
 	break;
     case FQDN_HITS:
-	*(Answer->val.integer) = FqdncacheStats.hits;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    FqdncacheStats.hits,
+	    SMI_COUNTER32);
 	break;
     case FQDN_PENDHIT:
-	*(Answer->val.integer) = FqdncacheStats.pending_hits;
-	Answer->type = SMI_GAUGE32;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    FqdncacheStats.pending_hits,
+	    SMI_GAUGE32);
 	break;
     case FQDN_NEGHIT:
-	*(Answer->val.integer) = FqdncacheStats.negative_hits;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    FqdncacheStats.negative_hits,
+	    SMI_COUNTER32);
 	break;
     case FQDN_MISS:
-	*(Answer->val.integer) = FqdncacheStats.misses;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    FqdncacheStats.misses,
+	    SMI_COUNTER32);
 	break;
     case FQDN_GHBN:
-	*(Answer->val.integer) = FqdncacheStats.ghba_calls;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    FqdncacheStats.ghba_calls,
+	    SMI_COUNTER32);
 	break;
     default:
 	*ErrP = SNMP_ERR_NOSUCHNAME;
-	snmp_var_free(Answer);
-	return (NULL);
+	break;
     }
     return Answer;
 }
